<id>
MD5 Encryption patch for Password Security (YaBB 1.3.x)
</id>

<version>
1.1 (YaBB 1.3.x)
</version>

<mod info>
This mod adds on to the Password Security mod by DummyProof and others. It changes the method of passwords encoded from the crypt function provided by Perl to MD5 (as used by YaBB 2). It also adds an extra layer of security: Passwords are now encrypted client-side when logging in before sending it to the server using Javascript.

This mod requires the original Password Security mod!

This mod was only tested on YaBB 1.3.1, but it *should* work on other versions with minimal modifications.

Features:
- Uses MD5 encryption instead of crypt()
- Uses Javascript MD5 library (included) with a default setting set by the admin.
- Converts crypted passwords to MD5 at login time.

To install:
Use BoardMod like normal
Upload these files in Sources/: Subs.pl, Profile.pl, LogInOut.pl, Register.pl, Admin.pl, AdminEdit.pl
Upload english.lng
Upload md5.js (included in zip file) to the same directory as ubbc.js.

If you do not have Digest::MD5 or Digest::Perl::MD5 on your server, you must download one from CPAN (http://search.cpan.org, search for "md5") and put it in Modules/Digest/Perl for Digest::Perl::MD5 or Modules/Digest for Digest::MD5.

Version History:
1.1 (YaBB 1.3.x): Removed plaintext conversion to make it safer. (December 3rd, 2005)
1.0 (YaBB 1.3.x): Mod package made available on BoardMod. (December 1st, 2005)
</mod info>

<author>
AK108
</author>

<homepage>
http://fkp.jkcsi.com/
</homepage>

<modfile generator id>modfilegen v1.1</modfile generator id>

<edit file>
german.lng
</edit file>
<search for>
$pwtxt{'759'} = "Die Antwort auf die geheime Frage MUSS ausgefllt werden.";
$pwtxt{'760'} = "Sorry, die Antwort ist falsch!";
</search for>
<add after>
# Begin AK108 MD5 password encryption add-on
$pwtxt{'761'} = "Diese Routine ist veraltet. Das Passwort wird jetzt beim Login konvertiert.";
$pwtxt{'762'} = "Standard auf Passwort-Verschlsselung beim Login?";
$pwtxt{'763'} = "Passwort vor bertragung an den Server verschlsseln?";
$pwtxt{'764'} = "Passwort verschlsselt versenden?";
$pwtxt{'765'} = "Kann das Modul Digest::MD5 oder Digest::Perl::MD5 nicht laden! Bitte berprfen, ob eines dieser Module verfgbar ist.";
$pwtxt{'766'} = "Dein Browser untersttzt keine <br> Verschlsselung beim Login.";
</add after>

<edit file>
Sources/Admin.pl
</edit file>
<search for>
        - <a href="$cgi;action=clean_log" onclick="return confirm('$txt{'203'}')">$txt{'202'}</a><br>
        - <a href="$cgi;action=boardrecount">$txt{'502'}</a><br>
        - <a href="$scripturl?action=notifymanage">$shnot{'1'}</a><BR>
        - <a href="$cgi&action=repairpasswords">$pwtxt{'750'}</a><br>
        - <a href="$cgi;action=membershiprecount">$txt{'504'}</a><br>
</search for>
<replace>
        - <a href="$cgi;action=clean_log" onclick="return confirm('$txt{'203'}')">$txt{'202'}</a><br>
        - <a href="$cgi;action=boardrecount">$txt{'502'}</a><br>
        - <a href="$scripturl?action=notifymanage">$shnot{'1'}</a><BR>
        - <a href="$cgi;action=membershiprecount">$txt{'504'}</a><br>
</replace>
<search for>

sub RepairPasswords {
        &is_admin;
	  @users = '';
        $yytitle = "$pwtxt{'750'}";
</search for>
<replace>

sub RepairPasswords {
	### THIS ROUTINE IS OBSOLETE! Password conversion is now done at login time
        &is_admin;
	&fatal_error($pwtxt{'761'});
	  @users = '';
        $yytitle = "$pwtxt{'750'}";
</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>
<search for>
	if ($maintenance) { $mainchecked = ' checked'; }
</search for>
<add before>
	if($sendencryptedpassbydefault) {$sendencryptedpassbydefaultcheck = ' checked="checked"';} # AK108
</add before>
<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailwelcome"$welchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
</search for>
<replace>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailwelcome"$welchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$pwtxt{'762'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="sendencryptedpassbydefault"$sendencryptedpassbydefaultcheck></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
</replace>
<search for>
	my @onoff = qw/
		testlinklive testlink allowaddlink linkconfirm allowpics showyabbcbutt showbdescrip maintenance guestaccess insert_original enable_ubbc enable_news enable_guestposting enable_notification showlatestmember showrecentbar showmarkread showmodify showuserpic showusertext showgenderimage shownewsfader MenuType curposlinks profilebutton autolinkurls emailpassword RegAgree emailwelcome allow_hide_email usetempfile faketruncation emailnewpass/;
</search for>
<add after>

	push(@onoff, 'sendencryptedpassbydefault'); # AK108
</add after>
<search for>
\$emailnewpass = $emailnewpass;				# Set to 1 to email a new password to members if they change their email address
\$emailwelcome = $emailwelcome;				# Set to 1 to email a welcome message to users even when you have mail password turned off

\$mailprog = "$mailprog";				# Location of your sendmail program
</search for>
<replace>
\$emailnewpass = $emailnewpass;				# Set to 1 to email a new password to members if they change their email address
\$emailwelcome = $emailwelcome;				# Set to 1 to email a welcome message to users even when you have mail password turned off
\$sendencryptedpassbydefault = $sendencryptedpassbydefault;				      # Set to 1 to try to have the user's password encoded when they login by default.

\$mailprog = "$mailprog";				# Location of your sendmail program
</replace>

<edit file>
Sources/LogInOut.pl
</edit file>
<search for>
$loginoutplver = "1 Gold - SP 1.3";

sub Login {
	$yymain .= qq~
<BR><BR>
<form action="$cgi;action=login2" method="POST" name="form">
<table border="0" width="60%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
</search for>
<replace>
$loginoutplver = "1 Gold - SP 1.3";

# Guess the MD5 script location based on the location of ubbc.js
# If you must, modify the location here. It's not worth another admin center entry.
$md5scriptsrc = $ubbcjspath;
$md5scriptsrc =~ s~ubbc\.js\Z~md5.js~i;

sub Login {
	my($encryptpasscheck);
	if($sendencryptedpassbydefault) {$sendencryptedpassbydefaultcheck = ' checked=\\"checked\\"';}
	$yymain .= qq~
<BR><BR>
<script language="JavaScript1.2" src="$md5scriptsrc" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function handlesubmit(theForm) {
	theForm.pwencrypted.value = "0";
	if(!theForm.encryptmypassword.checked) {return false;}
	else {
		var passwordtest = theForm.passwrd.value;
		theForm.passwrd.value = b64_md5(theForm.passwrd.value);
		if(passwordtest != theForm.passwrd.value) {
			theForm.pwencrypted.value = "1";
		}
		return true;
	}
}
-->
</script>
<form action="$cgi;action=login2" method="POST" name="form" onsubmit="handlesubmit(this);">
<input type="hidden" name="pwencrypted" value="0">
<table border="0" width="60%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
</replace>
<search for>
        <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="2"><font size=2><input type=checkbox name="cookieneverexp" tabindex="4" value="1" checked></font></td>
      </tr><tr>
        <td align=center colspan="3" class="windowbg" bgcolor="$color{'windowbg'}"><BR><input type=submit value="$txt{'34'}" tabindex="5" accesskey="l"></td>
      </tr><tr>
        <td align=center colspan="3" class="windowbg" bgcolor="$color{'windowbg'}"><BR></td>
</search for>
<replace>
        <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="2"><font size=2><input type=checkbox name="cookieneverexp" tabindex="4" value="1" checked></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><b id="pwencryptdesc">$pwtxt{'766'}</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="2"><font size=2 id="pwencryptcheck"></font></td>
      </tr><tr>
        <td align=center colspan="3" class="windowbg" bgcolor="$color{'windowbg'}"><BR><input type=submit value="$txt{'34'}" tabindex="6" accesskey="l"></td>
      </tr><tr>
        <td align=center colspan="3" class="windowbg" bgcolor="$color{'windowbg'}"><BR></td>
</replace>
<search for>
	document.form.username.focus();
//--> </script>
~;
	$yytitle = "$txt{'34'}";
</search for>
<replace>
	document.form.username.focus();
//--> </script>
<script language="JavaScript">
<!--
if(b64_md5) {
	document.getElementById("pwencryptdesc").innerHTML = \"$pwtxt{'764'}\\:\";
	document.getElementById("pwencryptcheck").innerHTML = \"\\<input type=checkbox name=\\"encryptmypassword\\" tabindex=\\"5\\" value=\\"1\\" $sendencryptedpassbydefaultcheck\\>\";
}
-->
</script>
~;
	$yytitle = "$txt{'34'}";
</replace>
<search for>
		fclose(FILE);
 		$settings[0] =~ s/[\n\r]//g;
		$password = crypt("$FORM{'passwrd'}",$pwseed);
		if($settings[0] ne $password) { $username = "Guest"; &fatal_error("$txt{'39'}"); }
		$settings[0] = "$settings[0]\n";
	}
	else { $username = "Guest"; &fatal_error("$txt{'40'}"); }
</search for>
<replace>
		fclose(FILE);
 		$settings[0] =~ s/[\n\r]//g;
		### There are a few possible cases here. We'll try them all. Less secure? Not really. Needed? Yes.
		my($formpass, $md5formpass, $cryptformpass, $storpass, $md5storpass, $passwordverified);
		# formpass = raw form password. md5formpass = formpass MD5 encrypted. cryptformpass = formpass crypted.
		# storpass = raw stored password. md5storpass = storpass MD5 encrypted.
		$formpass = $FORM{'passwrd'};
		$md5formpass = encode_password($formpass);
		$cryptformpass = crypt($formpass, $pwseed);
		$storpass = $settings[0];
		$md5storpass = encode_password($storpass);

		$passwordverified = 0; # By default, they aren't logged in.

		# There is good news about these conversion business.
		# The data output range of MD5 as base 64 and crypt are different by one character.
		# This means leaving conversion in long-term is safe, due to the lesser likelyhood of a match of crypt against a MD5'd password.
		# I can also check the existence of the old seed with the crypt conversion.
		if($FORM{'pwencrypted'}) { # formpass was MD5 encrypted by Javascript
			if($formpass eq $storpass) {
				# It seems both are encrypted.
				$passwordverified = 1;
			}
			elsif(index($storpass, $pwseed) > -1) {
				# formpass was encrypted, but storpass was encrypted using crypt.
				# We can't get around this. We MUST make the user log in using the unencrypted version.
				$username = 'Guest';
				&fatal_error("Sorry, but you must successfully login without password encryption enabled before you can login with it.");
			}
		}
		else { # The password sent was not reported to be encrypted
			if($cryptformpass eq $storpass) { #&& substr($storpass, 0, 2) eq $pwseed) {
				# Our stored password was crypted. Let's convert.
				$passwordverified = 1;
				$settings[0] = $md5formpass . "\n";

				# Time to reoutput their file
				fopen(FILE, ">$memberdir/$username.dat", 1);
				for($i = 0; $i <= scalar @settings; $i++) {
					print FILE $settings[$i];
				}
				fclose(FILE);
			}
			elsif($md5formpass eq $storpass) {
				# They just didn't login using the encrypted version
				$passwordverified = 1;
			}
		}

		### If they're not logged in, give them the invalid user error for more security.
		if(!$passwordverified) { $username = "Guest"; &fatal_error("$txt{'39'}"); }
		chomp $settings[0];
		$password = $settings[0];
		$settings[0] .= "\n";
	}
	else { $username = "Guest"; &fatal_error("$txt{'40'}"); }
</replace>
<search for>
	if($FORM{'cookielength'} < 1 || $FORM{'cookielength'} > 9999) { $FORM{'cookielength'} = $Cookie_Length; }
	if(!$FORM{'cookieneverexp'}) { $ck{'len'} = "\+$FORM{'cookielength'}m"; }
	else { $ck{'len'} = 'Sunday, 17-Jan-2038 00:00:00 GMT'; }
	$password = crypt("$FORM{'passwrd'}",$pwseed);
</search for>
<replace>
	if($FORM{'cookielength'} < 1 || $FORM{'cookielength'} > 9999) { $FORM{'cookielength'} = $Cookie_Length; }
	if(!$FORM{'cookieneverexp'}) { $ck{'len'} = "\+$FORM{'cookielength'}m"; }
	else { $ck{'len'} = 'Sunday, 17-Jan-2038 00:00:00 GMT'; }
</replace>
<search for>

sub sharedLogin {
	if ($sharedLogin_title ne "") {$yymain .= qq~<tr><td class="catbg" bgcolor="$color{'catbg'}" colspan="2"><font size="2" class="catbg"><b>$sharedLogin_title</b></font></td></tr>~;}
	if ($sharedLogin_text ne "") {$yymain .= qq~<tr><td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}" align="left" cellpadding=3><font size=2>$sharedLogin_text</font></td></tr>~;}
</search for>
<replace>

sub sharedLogin {
	my($encryptpasscheck);
	if($sendencryptedpassbydefault) {$sendencryptedpassbydefaultcheck = ' checked=\\"checked\\"';}
	if ($sharedLogin_title ne "") {$yymain .= qq~<tr><td class="catbg" bgcolor="$color{'catbg'}" colspan="2"><font size="2" class="catbg"><b>$sharedLogin_title</b></font></td></tr>~;}
	if ($sharedLogin_text ne "") {$yymain .= qq~<tr><td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}" align="left" cellpadding=3><font size=2>$sharedLogin_text</font></td></tr>~;}
</replace>
<search for>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign=middle align=center><img src="$imagesdir/login.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><BR>
        <form action="$cgi;action=login2" method="POST">
        <table border="0" cellpadding="2" cellspacing="0" valign="middle" align="center" width="90%">
          <tr>
</search for>
<replace>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign=middle align=center><img src="$imagesdir/login.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle"><BR>
        <script language="JavaScript1.2" src="$md5scriptsrc" type="text/javascript"></script>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
	function handlesubmit(theForm) {
		theForm.pwencrypted.value = "0";
		if(!theForm.encryptmypassword.checked) {return false;}
		else {
			var passwordtest = theForm.passwrd.value;
			theForm.passwrd.value = b64_md5(theForm.passwrd.value);
			if(passwordtest != theForm.passwrd.value) {
				theForm.pwencrypted.value = "1";
			}
			return true;
		}
	}
        -->
        </script>
        <form action="$cgi;action=login2" method="POST" onsubmit="handlesubmit(this);">
        <input type="hidden" name="pwencrypted" value="0">
        <table border="0" cellpadding="2" cellspacing="0" valign="middle" align="center" width="90%">
          <tr>
</replace>
<search for>
            <td valign="middle" align="left"><font size=2><b>$txt{'497'}:</b></font></td>
            <td valign="middle" align="left"><font size=2><input type=text name="cookielength" size="7" maxlength="4" value="$Cookie_Length" tabindex="3"> </font></td>
          </tr><tr>
            <td valign="middle" align="left"><font size=2><b>$txt{'36'}:</b></font></td>
            <td valign="middle" align="left"><font size=2><input type=password name="passwrd" size="15" tabindex="2"></font></td>
            <td valign="middle" align="left"><font size=2><b>$txt{'508'}:</b></font></td>
            <td valign="middle" align="left"><font size=2><input type=checkbox name="cookieneverexp" tabindex="4" checked>&nbsp;&nbsp;</font> <input type=submit value="$txt{'34'}" tabindex="5" accesskey="l"></font></td>
            <td valign="middle" align="left"><a href="$cgi;action=reminder"><font size="1">$txt{'315'}</font></a></td>
          </tr>
        </table>
        </form>
       </td>
      </tr>~;
</search for>
<replace>
            <td valign="middle" align="left"><font size=2><b>$txt{'497'}:</b></font></td>
            <td valign="middle" align="left"><font size=2><input type=text name="cookielength" size="7" maxlength="4" value="$Cookie_Length" tabindex="3"> </font></td>
            <td valign="middle" align="left"><font size=1 id="pwencryptdesc">$pwtxt{'766'}</font></td>
          </tr><tr>
            <td valign="middle" align="left"><font size=2><b>$txt{'36'}:</b></font></td>
            <td valign="middle" align="left"><font size=2><input type=password name="passwrd" size="15" tabindex="2"></font></td>
            <td valign="middle" align="left"><font size=2><b>$txt{'508'}:</b></font></td>
            <td valign="middle" align="left"><font size=2><input type=checkbox name="cookieneverexp" tabindex="4" checked>&nbsp;&nbsp;</font> <input type=submit value="$txt{'34'}" tabindex="6" accesskey="l"></font></td>
            <td valign="middle" align="left"><a href="$cgi;action=reminder"><font size="1">$txt{'315'}</font></a></td>
          </tr>
        </table>
        </form>
        <script language="JavaScript">
        <!--
        if(b64_md5) {
        	document.getElementById("pwencryptdesc").innerHTML = \"$pwtxt{'764'} <input type=\\"checkbox\\" tabindex=\\"5\\" name=\\"encryptmypassword\\"$sendencryptedpassbydefaultcheck\\>\";
        }
        -->
        </script>
       </td>
      </tr>~;
</replace>
<search for>
}

$cryptanswer = crypt("$FORM{'secretanswer'}",$pwseed);
&fatal_error("$pwtxt{'760'}") if($cryptanswer ne $member[21]);
$yytitle="$mbname $txt{'669'}";

</search for>
<replace>
}

$encodeanswer = encode_password($FORM{'secretanswer'});
$cryptanswer = crypt($FORM{'secretanswer'}, $pwseed);
&fatal_error($pwtxt{'760'}) if($cryptanswer ne $member[21] && $encodeanswer ne $member[21]);
$member[21] = $encodeanswer;
$yytitle="$mbname $txt{'669'}";

</replace>
<search for>
$_ =~ tr/0123456789/lkjhgfdaut/;
$newpasswrd .= $_;
$cryptpass = crypt($newpasswrd,$pwseed);

fopen( FILE, ">$memberdir/$user.dat", 1);
</search for>
<replace>
$_ =~ tr/0123456789/lkjhgfdaut/;
$newpasswrd .= $_;
$cryptpass = encode_password($newpasswrd);

fopen( FILE, ">$memberdir/$user.dat", 1);
</replace>

<edit file>
Sources/Profile.pl
</edit file>
<search for>
		}
		else {
			$cryptpass = crypt("$member{'passwrd1'}",$pwseed);
		}
                if ($member{'secretanswer'} eq $userProfileSettings[21]) {
</search for>
<replace>
		}
		else {
			$cryptpass = encode_password($member{'passwrd1'});
		}
                if ($member{'secretanswer'} eq $userProfileSettings[21]) {
</replace>
<search for>
		}
                else {
                        $cryptanswer = crypt("$member{'secretanswer'}",$pwseed);
		}

</search for>
<replace>
		}
                else {
                        $cryptanswer = encode_password($member{'secretanswer'});
		}

</replace>

<edit file>
Sources/Register.pl
</edit file>
<search for>
	fopen(FILE, ">$memberdir/$member{'username'}.dat");
	$cryptpass = crypt("$member{'passwrd1'}",$pwseed);
	print FILE "$cryptpass\n";
	print FILE "$member{'username'}\n";
</search for>
<replace>
	fopen(FILE, ">$memberdir/$member{'username'}.dat");
	$cryptpass = encode_password($member{'passwrd1'});
	print FILE "$cryptpass\n";
	print FILE "$member{'username'}\n";
</replace>
<search for>
	print FILE "$FORM{'hideemail'}\n";
	print FILE "$member{'secretquestion'}\n";
	$cryptanswer = crypt("$member{'secretanswer'}",$pwseed);
	print FILE "$cryptanswer\n";
	fclose(FILE);
</search for>
<replace>
	print FILE "$FORM{'hideemail'}\n";
	print FILE "$member{'secretquestion'}\n";
	$cryptanswer = encode_password($member{'secretanswer'});
	print FILE "$cryptanswer\n";
	fclose(FILE);
</replace>

<edit file>
Sources/Subs.pl
</edit file>
<search for>
1;
</search for>
<add before>

### Add the two possible module paths to @INC, plus the Modules directory at compile time
BEGIN {
	push(@INC, './Modules');
	push(@INC, './Modules/Digest');
	push(@INC, './Modules/Digest/Perl');
}
### encode_password routine from YaBB 2 adapted for use here
sub encode_password {
	my $string = $_[0];
	chomp $string;
	### Load MD5 Password encryption, one way or another
	if(eval "require Digest::MD5") {
		require Digest::MD5; import Digest::MD5 qw(md5_base64);
	}
	elsif(eval "require Digest::Perl::MD5") {
		require Digest::Perl::MD5; import Digest::Perl::MD5 qw(md5_base64);
	}
	else {
		&fatal_error($pwtxt{'765'});
	}
	my $mypass = md5_base64($string);
	return $mypass;
}

</add before>
